Index: /trunk/doc/manual/en_US/man_VBoxManage-cloud.xml
===================================================================
--- /trunk/doc/manual/en_US/man_VBoxManage-cloud.xml	(revision 99160)
+++ /trunk/doc/manual/en_US/man_VBoxManage-cloud.xml	(revision 99161)
@@ -55,6 +55,5 @@
         <arg choice="req">--profile=<replaceable>name</replaceable></arg>
         <sbr/>
-        <arg choice="plain">list</arg>
-        <arg choice="plain">instances</arg>
+        <arg choice="plain">list instances</arg>
         <arg>--state=<replaceable>string</replaceable></arg>
         <arg>--compartment-id=<replaceable>string</replaceable></arg>
@@ -65,6 +64,5 @@
       <arg choice="req">--profile=<replaceable>name</replaceable></arg>
       <sbr/>
-      <arg choice="plain">list</arg>
-      <arg choice="plain">images</arg>
+      <arg choice="plain">list images</arg>
       <arg choice="req">--compartment-id=<replaceable>string</replaceable></arg>
       <arg>--state=<replaceable>string</replaceable></arg>
@@ -75,8 +73,11 @@
       <arg choice="req">--profile=<replaceable>name</replaceable></arg>
       <sbr/>
-      <arg choice="plain">list</arg>
-      <arg choice="plain">vnicattachments</arg>
+      <arg choice="plain">list vnicattachments</arg>
       <arg choice="req">--compartment-id=<replaceable>string</replaceable></arg>
-      <arg>--filter=<replaceable>string</replaceable></arg>
+      <arg rep="repeat">--filter=<group choice="plain">
+          <arg choice="plain">instanceId</arg>
+          <arg choice="plain">vnicId</arg>
+          <arg choice="plain">availabilityDomain</arg>
+          </group>=<replaceable>value</replaceable></arg>
     </cmdsynopsis>
 
@@ -87,6 +88,5 @@
        <arg choice="req">--profile=<replaceable>name</replaceable></arg>
        <sbr/>
-       <arg choice="plain">instance</arg>
-       <arg choice="plain">create</arg>
+       <arg choice="plain">instance create</arg>
        <arg choice="req">--domain-name=<replaceable>name</replaceable></arg>
        <group choice="req">
@@ -98,8 +98,12 @@
        <arg choice="req">--subnet=<replaceable>id</replaceable></arg>
        <arg>--boot-disk-size=<replaceable>size in GB</replaceable></arg>
-       <arg>--publicip=<replaceable>true/false</replaceable></arg>
+       <arg>--publicip=<group choice="plain"><arg choice="plain">true</arg><arg choice="plain">false</arg></group></arg>
        <arg>--privateip=<replaceable>IP address</replaceable></arg>
        <arg rep="repeat">--public-ssh-key=<replaceable>key string</replaceable></arg>
-       <arg>--launch-mode=<replaceable>NATIVE/EMULATED/PARAVIRTUALIZED</replaceable></arg>
+       <arg>--launch-mode=<group choice="plain">
+           <arg choice="plain">NATIVE</arg>
+           <arg choice="plain">EMULATED</arg>
+           <arg choice="plain">PARAVIRTUALIZED</arg>
+         </group></arg>
        <arg>--cloud-init-script-path=<replaceable>path to a script</replaceable></arg>
      </cmdsynopsis>
@@ -109,6 +113,5 @@
        <arg choice="req">--profile=<replaceable>name</replaceable></arg>
        <sbr/>
-       <arg choice="plain">instance</arg>
-       <arg choice="plain">info</arg>
+       <arg choice="plain">instance info</arg>
        <arg choice="req">--id=<replaceable>unique id</replaceable></arg>
      </cmdsynopsis>
@@ -118,6 +121,5 @@
        <arg choice="req">--profile=<replaceable>name</replaceable></arg>
        <sbr/>
-       <arg choice="plain">instance</arg>
-       <arg choice="plain">terminate</arg>
+       <arg choice="plain">instance terminate</arg>
        <arg choice="req">--id=<replaceable>unique id</replaceable></arg>
      </cmdsynopsis>
@@ -127,6 +129,5 @@
        <arg choice="req">--profile=<replaceable>name</replaceable></arg>
        <sbr/>
-       <arg choice="plain">instance</arg>
-       <arg choice="plain">start</arg>
+       <arg choice="plain">instance start</arg>
        <arg choice="req">--id=<replaceable>unique id</replaceable></arg>
      </cmdsynopsis>
@@ -136,6 +137,5 @@
        <arg choice="req">--profile=<replaceable>name</replaceable></arg>
        <sbr/>
-       <arg choice="plain">instance</arg>
-       <arg choice="plain">pause</arg>
+       <arg choice="plain">instance pause</arg>
        <arg choice="req">--id=<replaceable>unique id</replaceable></arg>
      </cmdsynopsis>
@@ -145,6 +145,5 @@
        <arg choice="req">--profile=<replaceable>name</replaceable></arg>
        <sbr/>
-       <arg choice="plain">instance</arg>
-       <arg choice="plain">reset</arg>
+       <arg choice="plain">instance reset</arg>
        <arg choice="req">--id=<replaceable>unique id</replaceable></arg>
      </cmdsynopsis>
@@ -156,6 +155,5 @@
           <arg choice="req">--profile=<replaceable>name</replaceable></arg>
           <sbr/>
-          <arg choice="plain">image</arg>
-          <arg choice="plain">create</arg>
+          <arg choice="plain">image create</arg>
           <arg choice="req">--display-name=<replaceable>name</replaceable></arg>
           <arg>--bucket-name=<replaceable>name</replaceable></arg>
@@ -168,6 +166,5 @@
         <arg choice="req">--profile=<replaceable>name</replaceable></arg>
         <sbr/>
-        <arg choice="plain">image</arg>
-        <arg choice="plain">info</arg>
+        <arg choice="plain">image info</arg>
         <arg choice="req">--id=<replaceable>unique id</replaceable></arg>
       </cmdsynopsis>
@@ -177,6 +174,5 @@
         <arg choice="req">--profile=<replaceable>name</replaceable></arg>
         <sbr/>
-        <arg choice="plain">image</arg>
-        <arg choice="plain">delete</arg>
+        <arg choice="plain">image delete</arg>
         <arg choice="req">--id=<replaceable>unique id</replaceable></arg>
       </cmdsynopsis>
@@ -186,6 +182,5 @@
         <arg choice="req">--profile=<replaceable>name</replaceable></arg>
         <sbr/>
-        <arg choice="plain">image</arg>
-        <arg choice="plain">import</arg>
+        <arg choice="plain">image import</arg>
         <arg choice="req">--id=<replaceable>unique id</replaceable></arg>
         <arg>--bucket-name=<replaceable>name</replaceable></arg>
@@ -197,6 +192,5 @@
         <arg choice="req">--profile=<replaceable>name</replaceable></arg>
         <sbr/>
-        <arg choice="plain">image</arg>
-        <arg choice="plain">export</arg>
+        <arg choice="plain">image export</arg>
         <arg choice="req">--id=<replaceable>unique id</replaceable></arg>
         <arg choice="req">--display-name=<replaceable>name</replaceable></arg>
@@ -243,11 +237,9 @@
     </cmdsynopsis>
     <cmdsynopsis id="synopsis-vboxmanage-cloud-network-delete">
-      <command>VBoxManage cloud</command>
-      <arg choice="plain">network delete</arg>
+      <command>VBoxManage cloud network delete</command>
       <arg choice="req">--name=<replaceable>string</replaceable></arg>
     </cmdsynopsis>
     <cmdsynopsis id="synopsis-vboxmanage-cloud-network-info">
-      <command>VBoxManage cloud</command>
-      <arg choice="plain">network info</arg>
+      <command>VBoxManage cloud >network info</command>
       <arg choice="req">--name=<replaceable>string</replaceable></arg>
     </cmdsynopsis>
@@ -310,7 +302,8 @@
       <variablelist>
         <varlistentry>
-          <term>--state<replaceable>"available/disabled/deleted"</replaceable></term>
+          <term>--state=available|disabled|deleted</term>
           <listitem>
-            <para>The state of cloud image. The possible states are "available/disabled/deleted" at moment.
+            <para>The state of cloud image. The possible states are <literal>available</literal>,
+            <literal>disabled</literal> and <literal>deleted</literal> at moment.
             If the state isn't provided the list of images with all possible states is returned.
             </para>
@@ -336,10 +329,11 @@
       <variablelist>
         <varlistentry>
-          <term>--filter<replaceable>"instanceId/vnicId/domainName=string"</replaceable></term>
+          <term>--filter={instanceId|vnicId|domainName}=<replaceable>string</replaceable></term>
           <listitem>
+<!-- @todo r=bird: Use more markup. This'll all be put jumbled together into a single paragraph -->
             <para>Filters are used to narrow down the set of Vnic attachments of interest.
             This parameter is repeatible.
-            The possible filters are "instanceId" or "vnicId" or "availabilityDomain" at moment.
-            The form is "instanceId/vnicId/domainName=[string value]" and can be repeated.
+            The possible filter types are "instanceId" or "vnicId" or "availabilityDomain" at moment.
+            The form is "type=[value]" and can be repeated.
             In instance, "--filter instanceId=ocid1.instance.oc1.iad.anuwcl...js6
                           --filter vnicId=ocid1.vnic.oc1.iad.abuwcl...jsm
@@ -366,4 +360,5 @@
       <remark role="help-copy-synopsis"/>
       <para>
+<!-- @todo r=bird: Use more markup. This'll all be put jumbled together into a single paragraph -->
         Creates new instance in the Cloud.
         There are two standard ways to create an instance in the Cloud:
@@ -408,4 +403,5 @@
               <para>Public SSH key used to connect to the instance via SSH.
                 This parameter may be repeated if you plan to use more than one key as:
+<!-- @todo r=bird: Markup rather than quoting -->
                 "--public-ssh-key=firstSSHKey --public-ssh-key=secondSSHKey".
               </para>
Index: /trunk/doc/manual/en_US/man_VBoxManage-cloudprofile.xml
===================================================================
--- /trunk/doc/manual/en_US/man_VBoxManage-cloudprofile.xml	(revision 99160)
+++ /trunk/doc/manual/en_US/man_VBoxManage-cloudprofile.xml	(revision 99161)
@@ -115,23 +115,30 @@
       <variablelist>
         <varlistentry>
-          <term><option>--clouduser</option></term><listitem><para>The name which fully identifies the user in the specified cloud provider.</para></listitem>
-        </varlistentry>
-        <varlistentry>
-          <term><option>--fingerprint</option></term><listitem><para>Fingerprint for the key pair being used.</para></listitem>
-        </varlistentry>
-        <varlistentry>
-          <term><option>--keyfile</option></term><listitem><para>Full path and filename of the private key. </para></listitem>
-        </varlistentry>
-        <varlistentry>
-        <term><option>--passphrase</option></term><listitem><para>Passphrase used for the key, if it is encrypted.</para></listitem>
-      </varlistentry>
-      <varlistentry>
-        <term><option>--tenancy</option></term><listitem><para>ID of your tenancy. </para></listitem>
-      </varlistentry>
-      <varlistentry>
-        <term><option>--compartment</option></term><listitem><para>ID of your compartment.</para></listitem>
-      </varlistentry>
-      <varlistentry>
-        <term><option>--region</option></term><listitem><para>Region name. Region is where you plan to deploy an application.</para></listitem>
+          <term><option>--clouduser=<replaceable>unique id</replaceable></option></term>
+          <listitem><para>The name which fully identifies the user in the specified cloud provider.</para></listitem>
+        </varlistentry>
+        <varlistentry>
+          <term><option>--fingerprint=<replaceable>MD5 string</replaceable></option></term>
+          <listitem><para>Fingerprint for the key pair being used.</para></listitem>
+        </varlistentry>
+        <varlistentry>
+          <term><option>--keyfile=<replaceable>path</replaceable></option></term>
+          <listitem><para>Full path and filename of the private key. </para></listitem>
+        </varlistentry>
+        <varlistentry>
+        <term><option>--passphrase=<replaceable>string</replaceable></option></term>
+        <listitem><para>Passphrase used for the key, if it is encrypted.</para></listitem>
+      </varlistentry>
+      <varlistentry>
+        <term><option>--tenancy=<replaceable>unique id</replaceable></option></term>
+        <listitem><para>ID of your tenancy. </para></listitem>
+      </varlistentry>
+      <varlistentry>
+        <term><option>--compartment=<replaceable>unique id</replaceable></option></term>
+        <listitem><para>ID of your compartment.</para></listitem>
+      </varlistentry>
+      <varlistentry>
+        <term><option>--region=<replaceable>string</replaceable></option></term>
+        <listitem><para>Region name. Region is where you plan to deploy an application.</para></listitem>
       </varlistentry>
       </variablelist>
@@ -154,23 +161,30 @@
       <variablelist>
         <varlistentry>
-          <term><option>--clouduser</option></term><listitem><para>The name which fully identifies the user in the specified cloud provider.</para></listitem>
-        </varlistentry>
-        <varlistentry>
-          <term><option>--fingerprint</option></term><listitem><para>Fingerprint for the key pair being used.</para></listitem>
-        </varlistentry>
-        <varlistentry>
-          <term><option>--keyfile</option></term><listitem><para>Full path and filename of the private key. </para></listitem>
-        </varlistentry>
-        <varlistentry>
-        <term><option>--passphrase</option></term><listitem><para>Passphrase used for the key, if it is encrypted.</para></listitem>
-      </varlistentry>
-      <varlistentry>
-        <term><option>--tenancy</option></term><listitem><para>ID of your tenancy. </para></listitem>
-      </varlistentry>
-      <varlistentry>
-        <term><option>--compartment</option></term><listitem><para>ID of your compartment.</para></listitem>
-      </varlistentry>
-      <varlistentry>
-        <term><option>--region</option></term><listitem><para>Region name. Region is where you plan to deploy an application.</para></listitem>
+          <term><option>--clouduser=<replaceable>unique id</replaceable></option></term>
+          <listitem><para>The name which fully identifies the user in the specified cloud provider.</para></listitem>
+        </varlistentry>
+        <varlistentry>
+          <term><option>--fingerprint=<replaceable>MD5 string</replaceable></option></term>
+          <listitem><para>Fingerprint for the key pair being used.</para></listitem>
+        </varlistentry>
+        <varlistentry>
+          <term><option>--keyfile=<replaceable>path</replaceable></option></term>
+          <listitem><para>Full path and filename of the private key. </para></listitem>
+        </varlistentry>
+        <varlistentry>
+        <term><option>--passphrase=<replaceable>string</replaceable></option></term>
+        <listitem><para>Passphrase used for the key, if it is encrypted.</para></listitem>
+      </varlistentry>
+      <varlistentry>
+        <term><option>--tenancy=<replaceable>unique id</replaceable></option></term>
+        <listitem><para>ID of your tenancy. </para></listitem>
+      </varlistentry>
+      <varlistentry>
+        <term><option>--compartment=<replaceable>unique id</replaceable></option></term>
+        <listitem><para>ID of your compartment.</para></listitem>
+      </varlistentry>
+      <varlistentry>
+        <term><option>--region=<replaceable>string</replaceable></option></term>
+        <listitem><para>Region name. Region is where you plan to deploy an application.</para></listitem>
       </varlistentry>
       </variablelist>