Index: /trunk/doc/manual/en_US/man_VBoxManage-common.xml
===================================================================
--- /trunk/doc/manual/en_US/man_VBoxManage-common.xml	(revision 99175)
+++ /trunk/doc/manual/en_US/man_VBoxManage-common.xml	(revision 99176)
@@ -51,9 +51,4 @@
       <command>VBoxManage</command>
       <group>
-        <arg choice="plain">-V</arg>
-        <arg choice="plain">--version</arg>
-      </group>
-      <arg>--dump-build-type</arg>
-      <group>
         <arg choice="plain">-q</arg>
         <arg choice="plain">--nologo</arg>
@@ -62,5 +57,22 @@
       <arg>--settingspwfile=<replaceable>pw-file</replaceable></arg>
       <arg>@<replaceable>response-file</replaceable></arg>
-      <arg><arg>help</arg> <replaceable>subcommand</replaceable></arg>
+      <arg><replaceable>subcommand</replaceable></arg>
+    </cmdsynopsis>
+    <cmdsynopsis  id="synopsis-vboxmanage-common-help">
+      <command>VBoxManage help</command>
+      <arg><replaceable>subcommand</replaceable></arg>
+    </cmdsynopsis>
+    <cmdsynopsis id="synopsis-vboxmanage-common-commands">
+      <command>VBoxManage commands</command>
+    </cmdsynopsis>
+    <cmdsynopsis id="synopsis-vboxmanage-common-version">
+      <command>VBoxManage</command>
+      <group>
+        <arg choice="plain">-V</arg>
+        <arg choice="plain">--version</arg>
+      </group>
+    </cmdsynopsis>
+    <cmdsynopsis id="synopsis-vboxmanage-common-dump-build-type">
+      <command>VBoxManage</command> <arg>--dump-build-type</arg>
     </cmdsynopsis>
   </refsynopsisdiv>
Index: /trunk/doc/manual/en_US/man_VBoxManage-controlvm.xml
===================================================================
--- /trunk/doc/manual/en_US/man_VBoxManage-controlvm.xml	(revision 99175)
+++ /trunk/doc/manual/en_US/man_VBoxManage-controlvm.xml	(revision 99176)
@@ -447,5 +447,11 @@
       <group choice="req">
         <arg choice="plain">on</arg>
-        <arg choice="plain">primary <replaceable>x-origin</replaceable>&nbsp;<replaceable>y-origin</replaceable>&nbsp;<replaceable>x-resolution</replaceable>&nbsp;<replaceable>y-resolution</replaceable>&nbsp;<replaceable>bpp</replaceable></arg>
+        <arg choice="plain">primary
+          <arg choice="req"><replaceable>x-origin</replaceable></arg>
+          <arg choice="req"><replaceable>y-origin</replaceable></arg>
+          <arg choice="req"><replaceable>x-resolution</replaceable></arg>
+          <arg choice="req"><replaceable>y-resolution</replaceable></arg>
+          <arg choice="req"><replaceable>bpp</replaceable></arg>
+        </arg>
         <arg choice="plain">off</arg>
       </group>
@@ -486,5 +492,5 @@
         <arg choice="plain">all</arg>
         <arg choice="plain">none</arg>
-        <arg choice="plain"><replaceable>screen-ID</replaceable>[,<replaceable>screen-ID</replaceable>...]</arg>
+        <arg choice="plain"><replaceable>screen-ID</replaceable><arg rep="repeat">,<replaceable>screen-ID</replaceable></arg></arg>
       </group>
     </cmdsynopsis>
@@ -507,5 +513,5 @@
       </group>
       <arg choice="plain">recording videores</arg>
-      <arg choice="req"><replaceable>width</replaceable>x<replaceable>height</replaceable></arg>
+      <arg choice="req"><arg choice="req"><replaceable>width</replaceable></arg>x<arg choice="req"><replaceable>height</replaceable></arg></arg>
     </cmdsynopsis>
 
@@ -650,5 +656,5 @@
       </group>
       <arg choice="plain">webcam attach</arg>
-      <arg><replaceable>pathname</replaceable><arg><replaceable>settings</replaceable></arg></arg>
+      <arg><replaceable>pathname</replaceable> <arg><replaceable>settings</replaceable></arg></arg>
     </cmdsynopsis>
 
@@ -718,9 +724,9 @@
       <group choice="plain">
         <arg choice="plain">disconnected</arg>
-        <arg choice="plain">server <replaceable>pipe-name</replaceable></arg>
-        <arg choice="plain">client <replaceable>pipe-name</replaceable></arg>
-        <arg choice="plain">tcpserver <replaceable>port</replaceable></arg>
-        <arg choice="plain">tcpclient <replaceable>hostname</replaceable>:<replaceable>port</replaceable></arg>
-        <arg choice="plain">file <replaceable>filename</replaceable></arg>
+        <arg choice="plain"><arg choice="plain">server</arg> <arg choice="req"><replaceable>pipe-name</replaceable></arg></arg>
+        <arg choice="plain"><arg choice="plain">client</arg> <arg choice="req"><replaceable>pipe-name</replaceable></arg></arg>
+        <arg choice="plain"><arg choice="plain">tcpserver</arg> <arg choice="req"><replaceable>port</replaceable></arg></arg>
+        <arg choice="plain"><arg choice="plain">tcpclient</arg> <arg choice="req"><replaceable>hostname</replaceable>:<replaceable>port</replaceable></arg></arg>
+        <arg choice="plain"><arg choice="plain">file</arg> <arg choice="req"><replaceable>filename</replaceable></arg></arg>
         <arg choice="plain"><replaceable>device-name</replaceable></arg>
       </group>
@@ -746,5 +752,6 @@
         <arg choice="plain"><replaceable>vmname</replaceable></arg>
       </group>
-      <arg choice="plain">autostart-delay<replaceable>seconds</replaceable></arg>
+      <arg choice="plain">autostart-delay</arg>
+      <arg choice="req"><replaceable>seconds</replaceable></arg>
     </cmdsynopsis>
   </refsynopsisdiv>
Index: /trunk/doc/manual/en_US/man_VBoxManage-createmedium.xml
===================================================================
--- /trunk/doc/manual/en_US/man_VBoxManage-createmedium.xml	(revision 99175)
+++ /trunk/doc/manual/en_US/man_VBoxManage-createmedium.xml	(revision 99176)
@@ -78,6 +78,6 @@
           <arg choice="plain">RawDisk</arg>
       </group></arg> <!-- Value can be repated with comma separator. Difficult to express with docbook. -->
-      <arg rep="repeat">--property <replaceable>name</replaceable>=<replaceable>value</replaceable></arg>
-      <arg rep="repeat">--property-file <replaceable>name</replaceable>=<replaceable>/path/to/file/with/value</replaceable></arg>
+      <arg rep="repeat">--property=<replaceable>name</replaceable>=<replaceable>value</replaceable></arg>
+      <arg rep="repeat">--property-file=<replaceable>name</replaceable>=<replaceable>/path/to/file/with/value</replaceable></arg>
     </cmdsynopsis>
   </refsynopsisdiv>
@@ -190,5 +190,5 @@
       </varlistentry>
       <varlistentry>
-        <term><option>--property <replaceable>name</replaceable>=<replaceable>value</replaceable></option></term>
+        <term><option>--property=<replaceable>name</replaceable>=<replaceable>value</replaceable></option></term>
         <listitem><para>
             Specifies any required file format dependent parameters in
@@ -198,6 +198,5 @@
       </varlistentry>
       <varlistentry>
-        <term><option>--property-file <replaceable>name
-          </replaceable>=<replaceable>/path/to/file/with/value</replaceable></option></term>
+        <term><option>--property-file=<replaceable>name</replaceable>=<replaceable>/path/to/file/with/value</replaceable></option></term>
         <listitem><para>
             Specifies any required file format dependent parameters in
Index: /trunk/doc/manual/en_US/man_VBoxManage-createvm.xml
===================================================================
--- /trunk/doc/manual/en_US/man_VBoxManage-createvm.xml	(revision 99175)
+++ /trunk/doc/manual/en_US/man_VBoxManage-createvm.xml	(revision 99176)
@@ -53,11 +53,11 @@
       <arg>--basefolder=<replaceable>basefolder</replaceable></arg>
       <arg>--default</arg>
-      <arg>--group=<replaceable>group-ID</replaceable>,...</arg>
+      <arg>--group=<replaceable>group-ID</replaceable><arg rep="repeat">,</arg></arg>
       <arg>--ostype=<replaceable>ostype</replaceable></arg>
       <arg>--register</arg>
       <arg>--uuid=<replaceable>uuid</replaceable></arg>
-      <arg>--cipher <replaceable>cipher</replaceable></arg>
-      <arg>--password-id <replaceable>password-id</replaceable></arg>
-      <arg>--password <replaceable>file</replaceable></arg>
+      <arg>--cipher=<replaceable>cipher</replaceable></arg>
+      <arg>--password-id=<replaceable>password-id</replaceable></arg>
+      <arg>--password=<replaceable>file</replaceable></arg>
     </cmdsynopsis>
   </refsynopsisdiv>
@@ -113,5 +113,5 @@
       </varlistentry>
       <varlistentry>
-        <term><option>--group=<replaceable>group-ID</replaceable>,...</option></term>
+        <term><option>--group=<replaceable>group-ID</replaceable>[,...]</option></term>
         <listitem><para>
             Assigns the VM to the specified groups. If you specify more
@@ -154,5 +154,5 @@
       </varlistentry>
       <varlistentry>
-        <term><option>--cipher <replaceable>cipher</replaceable></option></term>
+        <term><option>--cipher=<replaceable>cipher</replaceable></option></term>
         <listitem><para>
             Specifies the cipher to use for encryption. Valid values are
@@ -164,5 +164,5 @@
       </varlistentry>
       <varlistentry>
-        <term><option>--password-id <replaceable>password-id</replaceable></option></term>
+        <term><option>--password-id=<replaceable>password-id</replaceable></option></term>
         <listitem><para>
             Specifies a new password identifier that is used for correct
@@ -173,5 +173,5 @@
       </varlistentry>
       <varlistentry>
-        <term><option>--password <replaceable>file</replaceable></option></term>
+        <term><option>--password=<replaceable>file</replaceable></option></term>
         <listitem><para>
             Use the <option>--password</option> to supply the encryption