Index: trunk/src/VBox/ValidationKit/tests/additions/tdAddGuestCtrl.py
===================================================================
--- trunk/src/VBox/ValidationKit/tests/additions/tdAddGuestCtrl.py	(revision 99278)
+++ trunk/src/VBox/ValidationKit/tests/additions/tdAddGuestCtrl.py	(revision 99279)
@@ -2320,5 +2320,5 @@
                          limitString(oTest.aEnv),));
         try:
-            if self.oTstDrv.fpApiVer >= 7.1:
+            if self.oTstDrv.fpApiVer >= 7.1 and self.oTstDrv.uRevision >= 156485:
                 oProcess = oGuestSession.processCreate(oTest.sCmd,
                                                        oTest.asArgs if self.oTstDrv.fpApiVer >= 5.0 else oTest.asArgs[1:],
@@ -2889,5 +2889,5 @@
             try:
                 reporter.log2('Starting stale process #%d...' % (i));
-                if self.oTstDrv.fpApiVer >= 7.1:
+                if self.oTstDrv.fpApiVer >= 7.1 and self.oTstDrv.uRevision >= 156485:
                     oGuestSession.processCreate(sShell,
                                                 asArgs if self.oTstDrv.fpApiVer >= 5.0 else asArgs[1:],
@@ -2930,5 +2930,5 @@
                 try:
                     reporter.log2('Starting non-stale process #%d...' % (i));
-                    if self.oTstDrv.fpApiVer >= 7.1:
+                    if self.oTstDrv.fpApiVer >= 7.1 and self.oTstDrv.uRevision >= 156485:
                         oCurProc = oGuestSession.processCreate(sShell, asArgs if self.oTstDrv.fpApiVer >= 5.0 else asArgs[1:],
                                                                "",         # Working directory.
@@ -2988,5 +2988,5 @@
                 try:
                     reporter.log2('Starting blocking process #%d...' % (i));
-                    if self.oTstDrv.fpApiVer >= 7.1:
+                    if self.oTstDrv.fpApiVer >= 7.1 and self.oTstDrv.uRevision >= 156485:
                         oCurProc = oGuestSession.processCreate(sCmd, asArgs if self.oTstDrv.fpApiVer >= 5.0 else asArgs[1:],
                                                                "", # Working directory.
@@ -3424,5 +3424,5 @@
         afFlags = [];
         try:
-            if self.oTstDrv.fpApiVer >= 7.1:
+            if self.oTstDrv.fpApiVer >= 7.1 and self.oTstDrv.uRevision >= 156485:
                 oGuestProcess = oGuestSession.processCreate(sImage,
                                                             asArgs if self.oTstDrv.fpApiVer >= 5.0 else asArgs[1:],
@@ -3547,5 +3547,5 @@
         fRc = True;
         try:
-            if self.oTstDrv.fpApiVer >= 7.1:
+            if self.oTstDrv.fpApiVer >= 7.1 and self.oTstDrv.uRevision >= 156485:
                 oCurProcess = oGuestSession.processCreate(sShell, [sShell,] if self.oTstDrv.fpApiVer >= 5.0 else [],
                                                           "", # Working directory.
@@ -3590,5 +3590,5 @@
             #
             try:
-                if self.oTstDrv.fpApiVer >= 7.1:
+                if self.oTstDrv.fpApiVer >= 7.1 and self.oTstDrv.uRevision >= 156485:
                     oCurProcess = oGuestSession.processCreate(sShell, [sShell,] if self.oTstDrv.fpApiVer >= 5.0 else [],
                                                               "", # Working directory.
@@ -3916,5 +3916,6 @@
             fUseDirList = False;
             cEntriesPerRead = random.randrange(1, 32768);
-            if self.oTstDrv.fpApiVer >= 7.1: # Listing directories only is available for >= VBox 7.1.
+            if self.oTstDrv.fpApiVer >= 7.1 and self.oTstDrv.uRevision >= 156485:
+                 # Listing directories only is available for >= VBox 7.1.
                 fUseDirList = random.choice( [True, False] );
             (fRc2, cDirs, cFiles, cOthers) = self.gctrlReadDirTree(oCurTest, oCurGuestSession, oCurRes.fRc,
@@ -3965,5 +3966,6 @@
                     fUseDirList = False;
                     cEntriesPerRead = random.randrange(1, 32768);
-                    if self.oTstDrv.fpApiVer >= 7.1: # Listing directories only is available for >= VBox 7.1.
+                    if self.oTstDrv.fpApiVer >= 7.1 and self.oTstDrv.uRevision >= 156485:
+                        # Listing directories only is available for >= VBox 7.1.
                         fUseDirList = random.choice( [True, False] );
                     fRc = self.gctrlReadDirTree2(oCurGuestSession, oDir, fUseDirList, cEntriesPerRead) and fRc;